Index: /trunk/src/sbin/routed/if.c
===================================================================
--- /trunk/src/sbin/routed/if.c	(revision 151)
+++ /trunk/src/sbin/routed/if.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: if.c,v 1.26 2007/08/14 03:39:19 dyoung Exp $	*/
+/*	$NetBSD: if.c,v 1.26.20.1 2010/08/16 18:43:55 matt Exp $	*/
 
 /*
@@ -38,5 +38,5 @@
 
 #ifdef __NetBSD__
-__RCSID("$NetBSD: if.c,v 1.26 2007/08/14 03:39:19 dyoung Exp $");
+__RCSID("$NetBSD: if.c,v 1.26.20.1 2010/08/16 18:43:55 matt Exp $");
 #elif defined(__FreeBSD__)
 __RCSID("$FreeBSD$");
@@ -84,4 +84,17 @@
 int	have_ripv1_out;			/* have a RIPv1 interface */
 int	have_ripv1_in;
+
+#ifdef sgi
+#define ROUNDUP(a) ((a) > 0 ? (1 + (((a) - 1) | (sizeof(__uint64_t) - 1))) \
+		    : sizeof(__uint64_t))
+#define	ROUNDUPMSG(a)	(a)
+#elif defined(__NetBSD__)
+#define ROUNDUP(a)	RT_ROUNDUP(a)
+#define	ROUNDUPMSG(a)	RT_ROUNDUP(a)
+#else
+#define ROUNDUP(a) ((a) > 0 ? (1 + (((a) - 1) | (sizeof(long) - 1))) \
+		    : sizeof(long))
+#define	ROUNDUPMSG(a)	(a)
+#endif
 
 
@@ -642,12 +655,4 @@
 	static struct sockaddr sa_zero;
 #endif
-#ifdef sgi
-#define ROUNDUP(a) ((a) > 0 ? (1 + (((a) - 1) | (sizeof(__uint64_t) - 1))) \
-		    : sizeof(__uint64_t))
-#else
-#define ROUNDUP(a) ((a) > 0 ? (1 + (((a) - 1) | (sizeof(long) - 1))) \
-		    : sizeof(long))
-#endif
-
 
 	memset(info, 0, sizeof(*info));
@@ -743,5 +748,5 @@
 	     ifam = ifam2) {
 
-		ifam2 = (struct ifa_msghdr*)((char*)ifam + ifam->ifam_msglen);
+		ifam2 = (struct ifa_msghdr*)((uintptr_t)ifam + ROUNDUPMSG(ifam->ifam_msglen));
 
 #ifdef RTM_OIFINFO
@@ -770,5 +775,6 @@
 			ifs0.int_data.odrops = ifm->ifm_data.ifi_odrops;
 #endif
-			sdl = (const struct sockaddr_dl *)(ifm + 1);
+			sdl = (const struct sockaddr_dl *)
+			    ((uintptr_t)ifm + ROUNDUP(sizeof(*ifm)));
 			/* NUL-termination by memset, above. */
 			memcpy(ifs0.int_name, sdl->sdl_data,
Index: /trunk/src/sbin/routed/table.c
===================================================================
--- /trunk/src/sbin/routed/table.c	(revision 151)
+++ /trunk/src/sbin/routed/table.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: table.c,v 1.22 2004/07/06 23:36:24 mycroft Exp $	*/
+/*	$NetBSD: table.c,v 1.22.38.1 2010/08/16 18:43:55 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #ifdef __NetBSD__
-__RCSID("$NetBSD: table.c,v 1.22 2004/07/06 23:36:24 mycroft Exp $");
+__RCSID("$NetBSD: table.c,v 1.22.38.1 2010/08/16 18:43:55 matt Exp $");
 #elif defined(__FreeBSD__)
 __RCSID("$FreeBSD$");
@@ -1093,6 +1093,6 @@
 		if (rtm->rtm_msglen == 0) {
 			msglog("zero length kernel route at "
-			       " %#lx in buffer %#lx before %#lx",
-			       (u_long)rtm, (u_long)sysctl_buf, (u_long)lim);
+			       " %p in buffer %p before %p",
+			       rtm, sysctl_buf, lim);
 			break;
 		}
Index: /trunk/src/share/mk/bsd.own.mk
===================================================================
--- /trunk/src/share/mk/bsd.own.mk	(revision 151)
+++ /trunk/src/share/mk/bsd.own.mk	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: bsd.own.mk,v 1.542.2.9.4.5 2010/04/21 05:26:47 matt Exp $
+#	bsd.own.mk,v 1.542.2.9.4.6 2011/04/29 07:48:36 matt Exp
 
 # This needs to be before bsd.init.mk
@@ -263,4 +263,5 @@
 TOOL_MKMAGIC=		${TOOLDIR}/bin/${_TOOL_PREFIX}file
 TOOL_MKTEMP=		${TOOLDIR}/bin/${_TOOL_PREFIX}mktemp
+TOOL_MKUBOOTIMAGE=	${TOOLDIR}/bin/${_TOOL_PREFIX}mkubootimage
 TOOL_MSGC=		MSGDEF=${TOOLDIR}/share/misc ${TOOLDIR}/bin/${_TOOL_PREFIX}msgc
 TOOL_MTREE=		${TOOLDIR}/bin/${_TOOL_PREFIX}mtree
@@ -331,4 +332,5 @@
 TOOL_MKMAGIC=		file
 TOOL_MKTEMP=		mktemp
+TOOL_MKUBOOTIMAGE=	mkubootimage
 TOOL_MSGC=		msgc
 TOOL_MTREE=		mtree
@@ -642,4 +644,11 @@
 # Don't let this build where it really isn't supported.
 MKCOMPAT:=	no
+.endif
+
+#
+# Default mips64 to softfloat now.
+#
+.if ${MACHINE_ARCH} == "mips64eb" || ${MACHINE_ARCH} == "mips64el"
+MKSOFTFLOAT?=   yes
 .endif
 
Index: /trunk/src/sys/arch/algor/algor/algor_p4032_intr.c
===================================================================
--- /trunk/src/sys/arch/algor/algor/algor_p4032_intr.c	(revision 151)
+++ /trunk/src/sys/arch/algor/algor/algor_p4032_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: algor_p4032_intr.c,v 1.20.16.2 2010/02/28 03:32:23 matt Exp $	*/
+/*	$NetBSD: algor_p4032_intr.c,v 1.20.16.3 2010/12/24 07:32:26 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: algor_p4032_intr.c,v 1.20.16.2 2010/02/28 03:32:23 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: algor_p4032_intr.c,v 1.20.16.3 2010/12/24 07:32:26 matt Exp $");
 
 #include "opt_ddb.h"
@@ -244,5 +244,4 @@
 		    EVCNT_TYPE_INTR, NULL, "mips", p4032_cpuintrnames[i]);
 	}
-	evcnt_attach_static(&mips_int5_evcnt);
 
 	for (i = 0; i < NIRQMAPS; i++) {
Index: /trunk/src/sys/arch/algor/algor/algor_p5064_intr.c
===================================================================
--- /trunk/src/sys/arch/algor/algor/algor_p5064_intr.c	(revision 151)
+++ /trunk/src/sys/arch/algor/algor/algor_p5064_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: algor_p5064_intr.c,v 1.23.16.2 2010/02/28 03:32:23 matt Exp $	*/
+/*	$NetBSD: algor_p5064_intr.c,v 1.23.16.3 2010/12/24 07:32:26 matt Exp $	*/
 
 /*-
@@ -39,5 +39,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: algor_p5064_intr.c,v 1.23.16.2 2010/02/28 03:32:23 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: algor_p5064_intr.c,v 1.23.16.3 2010/12/24 07:32:26 matt Exp $");
 
 #include "opt_ddb.h"
@@ -113,5 +113,5 @@
 #define	NIRQMAPS		(IRQMAP_ISABASE + NISAIRQS)
 
-const char *p5064_intrnames[NIRQMAPS] = {
+const char * const p5064_intrnames[NIRQMAPS] = {
 	/*
 	 * PCI INTERRUPTS
@@ -276,5 +276,5 @@
 
 struct p5064_cpuintr p5064_cpuintrs[NINTRS];
-const char *p5064_cpuintrnames[NINTRS] = {
+const char * const p5064_cpuintrnames[NINTRS] = {
 	"int 0 (isa)",
 	"int 1 (pci)",
@@ -282,5 +282,5 @@
 };
 
-const char *p5064_intrgroups[NINTRS] = {
+const char * const p5064_intrgroups[NINTRS] = {
 	"isa",
 	"pci",
@@ -323,5 +323,4 @@
 		    EVCNT_TYPE_INTR, NULL, "mips", p5064_cpuintrnames[i]);
 	}
-	evcnt_attach_static(&mips_int5_evcnt);
 
 	for (i = 0; i < NIRQMAPS; i++) {
Index: /trunk/src/sys/arch/algor/algor/algor_p6032_intr.c
===================================================================
--- /trunk/src/sys/arch/algor/algor/algor_p6032_intr.c	(revision 151)
+++ /trunk/src/sys/arch/algor/algor/algor_p6032_intr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: algor_p6032_intr.c,v 1.16.16.2 2010/02/28 03:32:23 matt Exp $	*/
+/*	$NetBSD: algor_p6032_intr.c,v 1.16.16.3 2010/12/24 07:32:26 matt Exp $	*/
 
 /*-
@@ -38,5 +38,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: algor_p6032_intr.c,v 1.16.16.2 2010/02/28 03:32:23 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: algor_p6032_intr.c,v 1.16.16.3 2010/12/24 07:32:26 matt Exp $");
 
 #include "opt_ddb.h"
@@ -198,5 +198,4 @@
 		    EVCNT_TYPE_INTR, NULL, "mips", p6032_cpuintrnames[i]);
 	}
-	evcnt_attach_static(&mips_int5_evcnt);
 
 	for (i = 0; i <= NIRQMAPS; i++) {
Index: /trunk/src/sys/arch/amd64/amd64/locore.S
===================================================================
--- /trunk/src/sys/arch/amd64/amd64/locore.S	(revision 151)
+++ /trunk/src/sys/arch/amd64/amd64/locore.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: locore.S,v 1.47.8.2 2009/02/02 03:24:05 snj Exp $	*/
+/*	$NetBSD: locore.S,v 1.47.8.2.4.1 2011/05/20 08:11:19 matt Exp $	*/
 
 /*
@@ -236,5 +236,5 @@
 
 	.globl	_C_LABEL(cpu_id),_C_LABEL(cpu_vendorname), _C_LABEL(cpu_brand_id)
-	.globl	_C_LABEL(cpuid_level),_C_LABEL(cpu_feature),_C_LABEL(cpu_feature2)
+	.globl	_C_LABEL(cpuid_level)
 	.globl	_C_LABEL(esym),_C_LABEL(eblob),_C_LABEL(boothowto)
 	.globl	_C_LABEL(bootinfo),_C_LABEL(atdevbase)
@@ -246,8 +246,4 @@
 					#   or Pentium, or..
 _C_LABEL(cpu_id):	.long	0	# saved from `cpuid' instruction
-_C_LABEL(cpu_feature):	.long	0	# feature flags from 'cpuid'
-					#   instruction
-_C_LABEL(cpu_feature2):	.long	0	# feature flags from 'cpuid'
-					#   instruction
 _C_LABEL(cpuid_level):	.long	-1	# max. level accepted by 'cpuid'
 					#   instruction
@@ -275,10 +271,22 @@
 
 #ifndef XEN
-	.globl	gdt64
-
-gdt64:
-	.word	gdt64_end-gdt64_start
+	.globl	gdt64_lo
+	.globl	gdt64_hi
+
+#define GDT64_LIMIT gdt64_end-gdt64_start-1
+
+/* Temporary gdt64, with base address in low memory */
+gdt64_lo:
+	.word	GDT64_LIMIT
 	.quad	_RELOC(gdt64_start)
 .align 64
+
+/* Temporary gdt64, with base address in high memory */
+gdt64_hi:
+	.word	GDT64_LIMIT
+	.quad	gdt64_start
+.align 64
+
+#undef GDT64_LIMIT
 
 gdt64_start:
@@ -289,5 +297,5 @@
 
 farjmp64:
-	.long	longmode-KERNBASE
+	.long	_RELOC(longmode)
 	.word	GSEL(GCODE_SEL, SEL_KPL)
 	
@@ -412,15 +420,8 @@
 	cpuid
 	movl	%eax,RELOC(cpu_id)
-	movl	%edx,RELOC(cpu_feature)
-	movl	%ecx,RELOC(cpu_feature2)
 
 	/* Brand ID is bits 0-7 of %ebx */
 	andl	$255,%ebx
 	movl	%ebx,RELOC(cpu_brand_id)
-
-	/* add AMD specific feature flags */
-	movl	$0x80000001,%eax
-	cpuid
-	orl	%edx,RELOC(cpu_feature)
 
 	/*
@@ -644,5 +645,5 @@
 	 */
 
-	movl	$RELOC(gdt64),%eax
+	movl	$RELOC(gdt64_lo),%eax
 	lgdt	(%eax)
 	movl	$RELOC(farjmp64),%eax
@@ -660,7 +661,15 @@
 	movabsq	$longmode_hi,%rax
 	jmp	*%rax
+
 longmode_hi:
-	/*
-	 * We have arrived.
+
+	/*
+	 * We left the identity mapped area. Base address of
+	 * the temporary gdt64 should now be in high memory.
+	 */
+	movq	$RELOC(gdt64_hi),%rax
+	lgdt	(%rax)
+
+	/*
 	 * There's no need anymore for the identity mapping in low
 	 * memory, remove it.
Index: /trunk/src/sys/arch/amd64/amd64/machdep.c
===================================================================
--- /trunk/src/sys/arch/amd64/amd64/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/amd64/amd64/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.102.4.10.4.1 2010/04/21 00:33:53 matt Exp $	*/
+/*	$NetBSD: machdep.c,v 1.102.4.10.4.2 2011/05/20 08:11:19 matt Exp $	*/
 
 /*-
@@ -113,5 +113,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.102.4.10.4.1 2010/04/21 00:33:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.102.4.10.4.2 2011/05/20 08:11:19 matt Exp $");
 
 /* #define XENDEBUG_LOW  */
@@ -1393,7 +1393,7 @@
 	first_bt_vaddr = (vaddr_t) (first_avail + KERNBASE + PAGE_SIZE * 2);
 	__PRINTK(("first_bt_vaddr 0x%lx\n", first_bt_vaddr));
-	cpu_feature = cpu_info_primary.ci_feature_flags;
 	/* not on Xen... */
-	cpu_feature &= ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR|CPUID_NOX);
+	cpu_feature &= ~(CPUID_PGE|CPUID_PSE|CPUID_MTRR|CPUID_FXSR);
+	cpu_feature3 &= ~(CPUID_NOX);
 #endif /* XEN */
 
Index: /trunk/src/sys/arch/amd64/amd64/mptramp.S
===================================================================
--- /trunk/src/sys/arch/amd64/amd64/mptramp.S	(revision 151)
+++ /trunk/src/sys/arch/amd64/amd64/mptramp.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mptramp.S,v 1.9 2008/05/13 22:39:17 ad Exp $	*/
+/*	$NetBSD: mptramp.S,v 1.9.16.1 2011/05/20 08:11:19 matt Exp $	*/
 
 /*-
@@ -224,5 +224,5 @@
 	jz	1b
 
-	movl	_C_LABEL(cpu_feature),%eax
+	movl	_C_LABEL(cpu_feature3),%eax
 	andl	$CPUID_NOX,%eax
 	jz	1f
Index: /trunk/src/sys/arch/amd64/amd64/netbsd32_machdep.c
===================================================================
--- /trunk/src/sys/arch/amd64/amd64/netbsd32_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/amd64/amd64/netbsd32_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: netbsd32_machdep.c,v 1.55.8.1 2010/04/21 00:33:53 matt Exp $	*/
+/*	$NetBSD: netbsd32_machdep.c,v 1.55.8.2 2011/05/20 08:11:19 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: netbsd32_machdep.c,v 1.55.8.1 2010/04/21 00:33:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: netbsd32_machdep.c,v 1.55.8.2 2011/05/20 08:11:19 matt Exp $");
 
 #include "opt_compat_netbsd.h"
@@ -943,5 +943,7 @@
 check_sigcontext32(const struct netbsd32_sigcontext *scp, struct trapframe *tf)
 {
-	if (((scp->sc_eflags ^ tf->tf_rflags) & PSL_USERSTATIC) != 0)
+
+	if (((scp->sc_eflags ^ tf->tf_rflags) & PSL_USERSTATIC) != 0 ||
+	    !VALID_USER_CSEL32(scp->sc_cs))
 		return EINVAL;
 	if (scp->sc_fs != 0 && !VALID_USER_DSEL32(scp->sc_fs))
@@ -965,5 +967,6 @@
 	gr = mcp->__gregs;
 
-	if (((gr[_REG32_EFL] ^ tf->tf_rflags) & PSL_USERSTATIC) != 0)
+	if (((gr[_REG32_EFL] ^ tf->tf_rflags) & PSL_USERSTATIC) != 0 ||
+	    !VALID_USER_CSEL32(gr[_REG32_CS]))
 		return EINVAL;
 	if (gr[_REG32_FS] != 0 && !VALID_USER_DSEL32(gr[_REG32_FS]))
Index: /trunk/src/sys/arch/amd64/include/segments.h
===================================================================
--- /trunk/src/sys/arch/amd64/include/segments.h	(revision 151)
+++ /trunk/src/sys/arch/amd64/include/segments.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: segments.h,v 1.19 2008/10/26 00:08:15 mrg Exp $	*/
+/*	$NetBSD: segments.h,v 1.19.12.1 2011/05/20 08:11:19 matt Exp $	*/
 
 /*-
@@ -383,8 +383,6 @@
     (((s) & 0xffff) == GSEL(GUDATA32_SEL, SEL_UPL) || \
      ((s) & 0xffff) == LSEL(LUDATA32_SEL, SEL_UPL))
-#if 0 /* not used */
 #define VALID_USER_CSEL32(s) \
     ((s) == GSEL(GUCODE32_SEL, SEL_UPL) || (s) == LSEL(LUCODE32_SEL, SEL_UPL))
-#endif
 
 #define VALID_USER_CSEL(s) \
Index: /trunk/src/sys/arch/amiga/amiga/amiga_init.c
===================================================================
--- /trunk/src/sys/arch/amiga/amiga/amiga_init.c	(revision 151)
+++ /trunk/src/sys/arch/amiga/amiga/amiga_init.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: amiga_init.c,v 1.99 2008/01/06 18:50:29 mhitch Exp $	*/
+/*	$NetBSD: amiga_init.c,v 1.99.26.1 2011/05/20 08:11:19 matt Exp $	*/
 
 /*
@@ -37,5 +37,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: amiga_init.c,v 1.99 2008/01/06 18:50:29 mhitch Exp $");
+__KERNEL_RCSID(0, "$NetBSD: amiga_init.c,v 1.99.26.1 2011/05/20 08:11:19 matt Exp $");
 
 #include <sys/param.h>
@@ -766,4 +766,5 @@
 start_c_finish()
 {
+	extern u_int32_t delaydivisor;
 #ifdef	P5PPC68KBOARD
         struct cfdev *cdp, *ecdp;
@@ -901,4 +902,19 @@
         }
 #endif
+	/*
+	 * preliminary delay divisor value
+	 */
+
+	if (machineid & AMIGA_68060)
+		delaydivisor = (1024 * 1) / 80;	/* 80 MHz 68060 w. BTC */
+
+	else if (machineid & AMIGA_68040)
+		delaydivisor = (1024 * 3) / 40;	/* 40 MHz 68040 */
+
+	else if (machineid & AMIGA_68030)
+		delaydivisor = (1024 * 8) / 50;	/* 50 MHz 68030 */
+
+	else
+		delaydivisor = (1024 * 8) / 33; /* 33 MHz 68020 */
 }
 
Index: /trunk/src/sys/arch/amiga/amiga/locore.s
===================================================================
--- /trunk/src/sys/arch/amiga/amiga/locore.s	(revision 151)
+++ /trunk/src/sys/arch/amiga/amiga/locore.s	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: locore.s,v 1.145 2008/01/06 18:50:30 mhitch Exp $	*/
+/*	$NetBSD: locore.s,v 1.145.28.1 2011/05/20 08:11:20 matt Exp $	*/
 
 /*
@@ -1578,4 +1578,14 @@
 #endif
 	nop
+ENTRY_NOPROFILE(delay)
+ENTRY_NOPROFILE(DELAY)
+	movql #10,%d1		| 2 +2
+	movl %sp@(4),%d0	| 4 +4
+	lsll %d1,%d0		| 8 +2
+	movl _C_LABEL(delaydivisor),%d1	| A +6
+Ldelay:				| longword aligned again.
+	subl %d1,%d0
+	jcc Ldelay
+	rts
 
 #ifdef M68060
@@ -1608,4 +1618,9 @@
 GLOBAL(protorp)
 	.long	0x80000002,0	| prototype root pointer
+GLOBAL(delaydivisor)
+	.long	12		| should be enough for 80 MHz 68060
+				| will be adapted to other CPUs in
+				| start_c_cleanup and calibrated
+				| at clock attach time.
 
 GLOBAL(proc0paddr)
Index: /trunk/src/sys/arch/amiga/dev/kbd.c
===================================================================
--- /trunk/src/sys/arch/amiga/dev/kbd.c	(revision 151)
+++ /trunk/src/sys/arch/amiga/dev/kbd.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: kbd.c,v 1.50 2007/12/28 20:49:49 joerg Exp $ */
+/*	$NetBSD: kbd.c,v 1.50.26.1 2011/05/20 08:11:20 matt Exp $ */
 
 /*
@@ -33,5 +33,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: kbd.c,v 1.50 2007/12/28 20:49:49 joerg Exp $");
+__KERNEL_RCSID(0, "$NetBSD: kbd.c,v 1.50.26.1 2011/05/20 08:11:20 matt Exp $");
 
 #include <sys/param.h>
@@ -563,5 +563,5 @@
 #endif
 	/* wait 200 microseconds (for bloody Cherry keyboards..) */
-	DELAY(2000);			/* fudge delay a bit for some keyboards */
+	DELAY(200);			/* fudge delay a bit for some keyboards */
 	ciaa.cra &= ~(1 << 6);
 
@@ -655,5 +655,5 @@
 	ciaa.sdr = 0xff;	/* ack */
 	/* wait 200 microseconds */
-	DELAY(2000);	/* XXXX only works as long as DELAY doesn't
+	DELAY(200);	/* XXXX only works as long as DELAY doesn't
 			 * use a timer and waits.. */
 	ciaa.cra &= ~(1 << 6);
Index: /trunk/src/sys/arch/arc/arc/autoconf.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.32 2007/12/03 15:33:12 ad Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.32.36.1 2010/12/29 01:44:20 matt Exp $	*/
 /*	$OpenBSD: autoconf.c,v 1.9 1997/05/18 13:45:20 pefo Exp $	*/
 
@@ -89,5 +89,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.32 2007/12/03 15:33:12 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.32.36.1 2010/12/29 01:44:20 matt Exp $");
 
 #include <sys/param.h>
@@ -149,7 +149,8 @@
 	 */
 	_spllower(MIPS_INT_MASK_5);
+#error need fix
 #else
 	/* enable all source forcing SOFT_INTs cleared */
-	_splnone();
+	spl0();
 #endif
 }
Index: /trunk/src/sys/arch/arc/arc/c_magnum.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/c_magnum.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/c_magnum.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: c_magnum.c,v 1.19 2008/03/14 16:43:27 tsutsui Exp $	*/
+/*	$NetBSD: c_magnum.c,v 1.19.22.1 2010/12/29 01:44:20 matt Exp $	*/
 /*	$OpenBSD: machdep.c,v 1.36 1999/05/22 21:22:19 weingart Exp $	*/
 
@@ -81,9 +81,12 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: c_magnum.c,v 1.19 2008/03/14 16:43:27 tsutsui Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: c_magnum.c,v 1.19.22.1 2010/12/29 01:44:20 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
+#include <sys/intr.h>
 #include <sys/device.h>
+
 #include <uvm/uvm_extern.h>
 
@@ -121,24 +124,18 @@
  * given interrupt priority level.
  */
-static const uint32_t magnum_ipl_sr_bits[_IPL_N] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] = 
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3,
-	[IPL_SCHED] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+static const struct ipl_sr_map magnum_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_1
+				| MIPS_INT_MASK_2
+				| MIPS_INT_MASK_3,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -231,5 +228,5 @@
 	 * Initialize interrupt priority
 	 */
-	ipl_sr_bits = magnum_ipl_sr_bits;
+	ipl_sr_map = magnum_ipl_sr_map;
 
 	/*
Index: /trunk/src/sys/arch/arc/arc/c_nec_eisa.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/c_nec_eisa.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/c_nec_eisa.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: c_nec_eisa.c,v 1.15 2008/05/14 13:29:27 tsutsui Exp $	*/
+/*	$NetBSD: c_nec_eisa.c,v 1.15.16.1 2010/12/29 01:44:20 matt Exp $	*/
 
 /*-
@@ -56,10 +56,13 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: c_nec_eisa.c,v 1.15 2008/05/14 13:29:27 tsutsui Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: c_nec_eisa.c,v 1.15.16.1 2010/12/29 01:44:20 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kcore.h>
 #include <sys/device.h>
+#include <sys/intr.h>
+
 #include <uvm/uvm_extern.h>
 
@@ -104,23 +107,17 @@
  * given interrupt priority level.
  */
-static const uint32_t nec_eisa_ipl_sr_bits[_IPL_N] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2,
-	[IPL_SCHED] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+static const struct ipl_sr_map nec_eisa_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_1
+				| MIPS_INT_MASK_2,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -162,5 +159,5 @@
 	 * Initialize interrupt priority
 	 */
-	ipl_sr_bits = nec_eisa_ipl_sr_bits;
+	ipl_sr_map = nec_eisa_ipl_sr_map;
 
 	/*
Index: /trunk/src/sys/arch/arc/arc/c_nec_pci.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/c_nec_pci.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/c_nec_pci.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: c_nec_pci.c,v 1.17 2007/12/03 15:33:13 ad Exp $	*/
+/*	$NetBSD: c_nec_pci.c,v 1.17.36.1 2010/12/29 01:44:20 matt Exp $	*/
 
 /*-
@@ -32,10 +32,13 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: c_nec_pci.c,v 1.17 2007/12/03 15:33:13 ad Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: c_nec_pci.c,v 1.17.36.1 2010/12/29 01:44:20 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/kcore.h>
 #include <sys/device.h>
+#include <sys/intr.h>
+
 #include <uvm/uvm_extern.h>
 
@@ -111,23 +114,17 @@
  * given interrupt priority level.
  */
-static const uint32_t nec_pci_ipl_sr_bits[_IPL_N] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 | 
-	    MIPS_INT_MASK_2,
-	[IPL_SCHED] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0 |
-	    MIPS_INT_MASK_1 |
-	    MIPS_INT_MASK_2 |
-	    MIPS_INT_MASK_3 |
-	    MIPS_INT_MASK_4 |
-	    MIPS_INT_MASK_5,
+static const struct ipl_sr_map nec_pci_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK
+				| MIPS_INT_MASK_0
+				| MIPS_INT_MASK_1
+				| MIPS_INT_MASK_2,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -187,5 +184,5 @@
 	 * Initialize interrupt priority
 	 */
-	ipl_sr_bits = nec_pci_ipl_sr_bits;
+	ipl_sr_map = nec_pci_ipl_sr_map;
 
 	/*
Index: /trunk/src/sys/arch/arc/arc/interrupt.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/interrupt.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/interrupt.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interrupt.c,v 1.4.22.1 2010/02/05 07:39:52 matt Exp $	*/
+/*	$NetBSD: interrupt.c,v 1.4.22.2 2010/12/29 01:44:20 matt Exp $	*/
 /*	$OpenBSD: trap.c,v 1.22 1999/05/24 23:08:59 jason Exp $	*/
 
@@ -79,5 +79,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.4.22.1 2010/02/05 07:39:52 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.4.22.2 2010/12/29 01:44:20 matt Exp $");
 
 #include <sys/param.h>
@@ -136,72 +136,57 @@
 /*
  * Handle an interrupt.
- * N.B., curlwp might be NULL.
  */
 void
-cpu_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
+	struct cpu_inttab *inttab;
 	struct clockframe cf;
-	struct cpu_inttab *inttab;
-	struct cpu_info *ci;
-	uint32_t handled;
+	uint32_t ipending;
 	u_int i;
+	int ipl;
 
-	handled = 0;
-	ci = curcpu();
 	uvmexp.intrs++;
-	ci->ci_idepth++;
 
 	cf.pc = pc;
 	cf.sr = status;
+	cf.intr = (curcpu()->ci_idepth > 1);
 
-	/* check MIPS3 internal clock interrupt */
-	if (ipending & MIPS_INT_MASK_5) {
+	while (ppl < (ipl = splintr(&ipending))) {
+		/* check MIPS3 internal clock interrupt */
+		if (ipending & MIPS_INT_MASK_5) {
 #ifdef ENABLE_INT5_STATCLOCK
-		/* call statclock(9) handler */
-		statclockintr(&cf);
-		statclock_ev.ev_count++;
+			/* call statclock(9) handler */
+			statclockintr(&cf);
+			statclock_ev.ev_count++;
 #else
+			/*
+			 * Writing a value to the Compare register, as a side
+			 * effect, clears the timer interrupt request.
+			 */
+			mips3_cp0_compare_write(0);
+		}
+#endif
+
 		/*
-		 *  Writing a value to the Compare register,
-		 *  as a side effect, clears the timer interrupt request.
+		 * If there is an independent timer interrupt handler,
+		 * call it first.
 		 */
-		mips3_cp0_compare_write(0);
-#endif
-		handled |= MIPS_INT_MASK_5;
+		inttab = &cpu_int_tab[ARC_INTPRI_TIMER_INT];
+		if (inttab->int_mask & ipending) {
+			(*inttab->int_hand)(ipending, &cf);
+		}
+
+		/*
+		 *  Check off all other enabled interrupts.
+		 *  Called handlers return mask of interrupts to be reenabled.
+		 */
+		for (inttab++, i = ARC_INTPRI_TIMER_INT + 1;
+		     i < ARC_NINTPRI;
+		     inttab++, i++) {
+			if (inttab->int_mask & ipending) {
+				(*inttab->int_hand)(ipending, &cf);
+			}
+		}
+		(void)splhigh();
 	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	/*
-	 *  If there is an independent timer interrupt handler, call it first.
-	 *  Called interrupt routine returns mask of interrupts to be reenabled.
-	 */
-	inttab = &cpu_int_tab[ARC_INTPRI_TIMER_INT];
-	if (inttab->int_mask & ipending) {
-		handled |= (*inttab->int_hand)(ipending, &cf);
-	}
-	_splset((status & handled) | MIPS_SR_INT_IE);
-
-	inttab++;
-
-	/*
-	 *  Check off all other enabled interrupts.
-	 *  Called handlers return mask of interrupts to be reenabled.
-	 */
-	for (i = ARC_INTPRI_TIMER_INT + 1; i < ARC_NINTPRI; i++) {
-		if (inttab->int_mask & ipending) {
-			handled |= (*inttab->int_hand)(ipending, &cf);
-		}
-		inttab++;
-	}
-	cause &= ~handled;
-	_splset((status & ~cause & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	/* software interrupts */
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
 }
Index: /trunk/src/sys/arch/arc/arc/p_dti_arcstation.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/p_dti_arcstation.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/p_dti_arcstation.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: p_dti_arcstation.c,v 1.13 2007/12/03 15:33:14 ad Exp $	*/
+/*	$NetBSD: p_dti_arcstation.c,v 1.13.36.1 2010/12/29 01:44:20 matt Exp $	*/
 /*	$OpenBSD: machdep.c,v 1.36 1999/05/22 21:22:19 weingart Exp $	*/
 
@@ -77,9 +77,12 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: p_dti_arcstation.c,v 1.13 2007/12/03 15:33:14 ad Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: p_dti_arcstation.c,v 1.13.36.1 2010/12/29 01:44:20 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
+#include <sys/intr.h>
+
 #include <uvm/uvm_extern.h>
 
@@ -138,26 +141,14 @@
  */
 /* XXX see comments in p_dti_arcstation_init() */
-static const uint32_t dti_arcstation_ipl_sr_bits[_IPL_N] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0|
-	    MIPS_INT_MASK_1|
-	    MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_3|
-	    MIPS_INT_MASK_4|
-	    MIPS_INT_MASK_5,
-	[IPL_SCHED] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0|
-	    MIPS_INT_MASK_1|
-	    MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_3|
-	    MIPS_INT_MASK_4|
-	    MIPS_INT_MASK_5,
+static const struct ipl_sr_map dti_arcstation_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
+	[IPL_VM] =		MIPS_INT_MASK,	/* XXX */
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+     },
 };
 
@@ -249,5 +240,5 @@
 	 *	- use MIP3_INTERNAL_TIMER_INTERRUPT for clock
 	 */
-	ipl_sr_bits = dti_arcstation_ipl_sr_bits;
+	ipl_sr_map = dti_arcstation_ipl_sr_map;
 
 	/*
Index: /trunk/src/sys/arch/arc/arc/p_dti_tyne.c
===================================================================
--- /trunk/src/sys/arch/arc/arc/p_dti_tyne.c	(revision 151)
+++ /trunk/src/sys/arch/arc/arc/p_dti_tyne.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: p_dti_tyne.c,v 1.16 2007/12/03 15:33:14 ad Exp $	*/
+/*	$NetBSD: p_dti_tyne.c,v 1.16.36.1 2010/12/29 01:44:21 matt Exp $	*/
 /*	$OpenBSD: machdep.c,v 1.36 1999/05/22 21:22:19 weingart Exp $	*/
 
@@ -76,6 +76,7 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: p_dti_tyne.c,v 1.16 2007/12/03 15:33:14 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: p_dti_tyne.c,v 1.16.36.1 2010/12/29 01:44:21 matt Exp $");
 
 #include <sys/param.h>
@@ -139,26 +140,16 @@
  */
 /* XXX see comments in p_dti_tyne_init() */
-static const uint32_t dti_tyne_ipl_sr_bits[_IPL_N] = {
-	[IPL_NONE] =0,
-	[IPL_SOFTCLOCK] =
-	    MIPS_SOFT_INT_MASK_0,
-	[IPL_SOFTNET] =
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1,
-	[IPL_VM] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0|
-	    MIPS_INT_MASK_1|
-	    MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_3|
-	    MIPS_INT_MASK_4|
-	    MIPS_INT_MASK_5,
-	[IPL_SCHED] =	/* XXX */
-	    MIPS_SOFT_INT_MASK_0 | MIPS_SOFT_INT_MASK_1 |
-	    MIPS_INT_MASK_0|
-	    MIPS_INT_MASK_1|
-	    MIPS_INT_MASK_2|
-	    MIPS_INT_MASK_3|
-	    MIPS_INT_MASK_4|
-	    MIPS_INT_MASK_5,
+static const struct ipl_sr_map dti_tyne_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] = 0,
+	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTBIO] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] = MIPS_SOFT_INT_MASK,
+	[IPL_SOFTSERIAL] = MIPS_SOFT_INT_MASK,
+	[IPL_VM] =	MIPS_INT_MASK, /* XXX */
+	[IPL_SCHED] =	MIPS_INT_MASK,
+	[IPL_DDB] =	MIPS_INT_MASK,
+	[IPL_HIGH] =	MIPS_INT_MASK,
+    },
 };
 
@@ -242,5 +233,5 @@
 	 *	- use MIP3_INTERNAL_TIMER_INTERRUPT for clock
 	 */
-	ipl_sr_bits = dti_tyne_ipl_sr_bits;
+	ipl_sr_map = dti_tyne_ipl_sr_map;
 
 	/*
